#include<bits/stdc++.h>
#define endl "\n"
using namespace std;
pair<int,int> a[50010];
int main(){
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
    int n;
    cin>>n;
    int Max=0;
    for(int i=0;i<n;i++){
        cin>>a[i].first>>a[i].second;
        Max=max(Max,a[i].second);
    }
    sort(a,a+n);
    int ans=0,br=0;
    priority_queue<int> pq;
    int i=0;
    for(int t=1;t<=Max;t++){
        while(a[i].first==t){
            pq.push(-a[i].second);
            i++;
        }
        while(!pq.empty() && -pq.top()<=t){
            pq.pop();
        }
        if(ans==pq.size()){
            br++;
        }
        if(ans<pq.size()){
            ans=pq.size();
            br=0;
        }
    }
    cout<<ans<<endl<<br;
    return 0;
}
